## ros-kinetic-epos2-motor-controller 1.0.1

=== CMakeLists.txt ===
# Pre-requisites about cmake itself
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0005 NEW) 
  cmake_policy(SET CMP0003 NEW)
   
endif(COMMAND cmake_policy)

# The project name and the type of project
PROJECT(libepos2)
SET(MAJOR_VERSION 0)
SET(MINOR_VERSION 4)
SET(VERSION_STRING ${MAJOR_VERSION}.${MINOR_VERSION})
SET(VERSION ${VERSION_STRING})

# automatically set lib suffix
IF(UNIX AND NOT APPLE AND NOT CMAKE_CROSSCOMPILING AND NOT EXISTS "/etc/debian_version")
  IF(CMAKE_SIZEOF_VOID_P EQUAL 8 AND NOT LIB_SUFFIX)
    SET(LIB_SUFFIX 64)
  ENDIF()
ENDIF()

# config script install path
IF(NOT DEFINED LIBEPOS2_CMAKE_CONFIG_DIR)
  SET( LIBEPOS2_CMAKE_CONFIG_DIR lib${LIB_SUFFIX}/cmake/libepos2)
ENDIF()


SET(prefix      ${CMAKE_INSTALL_PREFIX})
SET(exec_prefix ${CMAKE_INSTALL_PREFIX}/bin)
SET(includedir  ${CMAKE_INSTALL_PREFIX}/include/${PROJECT_NAME})

IF(${UNIX})
   SET(libdir      ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
ENDIF(${UNIX})
IF(${WIN32})
   SET(libdir      ${CMAKE_INSTALL_PREFIX}/bin)
ENDIF(${WIN32})

IF (NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Debug)
ENDIF (NOT CMAKE_BUILD_TYPE)

ADD_SUBDIRECTORY(src)

#FIND_PACKAGE(Doxygen)

#FIND_PATH(IRI_DOC_DIR doxygen.conf ${CMAKE_SOURCE_DIR}/doc/iri_doc/)
#IF (IRI_DOC_DIR)
#  ADD_CUSTOM_TARGET (doc ${DOXYGEN_EXECUTABLE} ${CMAKE_SOURCE_DIR}/doc/iri_doc/doxygen.conf)
#ELSE (IRI_DOC_DIR)
#  ADD_CUSTOM_TARGET (doc ${DOXYGEN_EXECUTABLE} ${CMAKE_SOURCE_DIR}/doc/doxygen.conf)
#ENDIF (IRI_DOC_DIR)

ADD_CUSTOM_TARGET (distclean @echo cleaning cmake files)

install(FILES package.xml DESTINATION share/libepos2)

IF (UNIX)
  ADD_CUSTOM_COMMAND(
    COMMENT "distribution clean"
    COMMAND make ARGS clean
    COMMAND rm ARGS -rf ${CMAKE_SOURCE_DIR}/build/CMakeFiles*
    COMMAND rm ARGS -rf ${CMAKE_SOURCE_DIR}/build/src*
    COMMAND rm ARGS CMakeCache.txt
    COMMAND rm ARGS cmake_install.cmake
    COMMAND rm ARGS install_manifest.txt
    COMMAND rm ARGS Makefile

    TARGET  distclean
  )
ELSE(UNIX)
  ADD_CUSTOM_COMMAND(
    COMMENT "distclean only implemented in unix"
    TARGET  distclean
  )
ENDIF(UNIX)

ADD_CUSTOM_TARGET (uninstall @echo uninstall package)

IF (UNIX)
  ADD_CUSTOM_COMMAND(
    COMMENT "uninstall package"
    COMMAND xargs ARGS rm < install_manifest.txt

    TARGET  uninstall
  )
ELSE(UNIX)
  ADD_CUSTOM_COMMAND(
    COMMENT "uninstall only implemented in unix"
    TARGET  uninstall
  )
ENDIF(UNIX)

ADD_CUSTOM_TARGET (dep @echo install package dependencies)

IF (UNIX)
  ADD_CUSTOM_COMMAND(
    COMMENT "make package dependencies"
    COMMAND ./make_dep.sh ARGS -d ../dependencies
    TARGET  dep
  )
ELSE(UNIX)
  ADD_CUSTOM_COMMAND(
    COMMENT "make package dependencies only implemented in unix"
    TARGET  dep
  )
ENDIF(UNIX)

IF (UNIX)
 SET(CPACK_PACKAGE_FILE_NAME "iri-${PROJECT_NAME}-dev-${CPACK_PACKAGE_VERSION}${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}")
 SET(CPACK_PACKAGE_NAME "iri-${PROJECT_NAME}-dev")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "This is a driver for Maxon EPOS2 Motor Controller for linux EPOS2 part of IRI-laboratory libraries. More information at http://wikiri.upc.es/index.php/Robotics_Lab")
 SET(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
 SET(CPACK_GENERATOR "DEB")
 SET(CPACK_DEBIAN_PACKAGE_MAINTAINER "galenya - labrobotica@iri.upc.edu")
 SET(CPACK_SET_DESTDIR "ON")  # Necessary because of the absolute install paths

 INCLUDE(CPack)
ELSE(UNIX)
 ADD_CUSTOM_COMMAND(
   COMMENT "packaging only implemented in unix"
   TARGET  uninstall
)
ENDIF(UNIX)

=== src/CMakeLists.txt ===
# driver source files
SET(sources Epos2.cpp)
# application header files
SET(headers Epos2.h)

# locate the necessary dependencies
FIND_PACKAGE(LibFTDI1 NO_MODULE REQUIRED)

# fix for LIBFTDI_USE_FILE location in xenial and missing libftdipp1
string(REGEX REPLACE "/usr//usr/" "/usr/" LIBFTDI_USE_FILE ${LIBFTDI_USE_FILE})
list(APPEND LIBFTDIPP_LIBRARIES ${LIBFTDI_LIBARIES} ftdipp1)

# add the necessary include directories
INCLUDE_DIRECTORIES(.)
INCLUDE(${LIBFTDI_USE_FILE})

# create the shared library
ADD_LIBRARY(epos2 SHARED ${sources})

# link necessary libraries
TARGET_LINK_LIBRARIES(epos2 ${LIBFTDIPP_LIBRARIES})

SET_TARGET_PROPERTIES(epos2 PROPERTIES VERSION ${VERSION} SOVERSION 0)

INSTALL(TARGETS epos2
  LIBRARY DESTINATION lib${LIB_SUFFIX}
  COMPONENT sharedlibs
)

INSTALL(FILES ${headers} DESTINATION include/${PROJECT_NAME} COMPONENT headers)

SET(LIBEPOS2_INCLUDE_DIR ${includedir})
SET(LIBEPOS2_INCLUDE_DIRS ${LIBEPOS2_INCLUDE_DIR})
GET_TARGET_PROPERTY(_LIBEPOS2_LIBRARY_LOCATION epos2 LOCATION)
GET_FILENAME_COMPONENT(_LIBEPOS2_LIBRARY_NAME ${_LIBEPOS2_LIBRARY_LOCATION} NAME)
SET(LIBEPOS2_LIBRARY ${libdir}/${_LIBEPOS2_LIBRARY_NAME})
SET(LIBEPOS2_LIBRARIES ${LIBEPOS2_LIBRARY})
LIST(APPEND LIBEPOS2_LIBRARIES ${LIBUSB_LIBRARIES})
SET(LIBEPOS2_ROOT_DIR ${prefix})
SET(LIBEPOS2_VERSION_STRING ${VERSION_STRING})
SET(LIBEPOS2_VERSION_MAJOR ${MAJOR_VERSION})
SET(LIBEPOS2_VERSION_MINOR ${MINOR_VERSION})
SET(LIBEPOS2_USE_FILE ${CMAKE_INSTALL_PREFIX}/${LIBEPOS2_CMAKE_CONFIG_DIR}/UseLibEPOS2.cmake)
CONFIGURE_FILE(../LibEPOS2Config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/LibEPOS2Config.cmake @ONLY)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/LibEPOS2Config.cmake ../UseLibEPOS2.cmake DESTINATION ${LIBEPOS2_CMAKE_CONFIG_DIR})

ADD_SUBDIRECTORY(examples)

=== debian/changelog ===
ros-kinetic-epos2-motor-controller (1.0.1-1xenial) xenial; urgency=high

  * fix for LIBFTDI_USE_FILE location in xenial and missing libftdipp1

 -- Sebastian Pütz <spuetz@uos.de>  Tue, 06 Aug 2019 22:00:00 -0000

ros-kinetic-epos2-motor-controller (1.0.0-1xenial) xenial; urgency=high

  * First release,c ontributors: Jochen Sprickerhof, galenya, mmorta

 -- Sebastian Pütz <spuetz@uos.de>  Mon, 22 Apr 2019 22:00:00 -0000

=== debian/control ===
Source: ros-kinetic-epos2-motor-controller
Section: misc
Priority: extra
Maintainer: Sebastian Pütz <spuetz@uos.de>
Build-Depends: debhelper (>= 9.0.0), cmake, libftdi-dev, libftdipp1-dev
Homepage: 
Standards-Version: 3.9.2

Package: ros-kinetic-epos2-motor-controller
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libftdi-dev, libftdipp1-dev
Description: EPOS2 motor controller driver

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-epos2-motor-controller//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
